
//Mon 31 Jul 2006 12:30:55 BST 

#include <gnome.h>
#include <glade/glade.h>
#include <glib/gstdio.h>
#include <glib.h>
#include <libgnomevfs/gnome-vfs-init.h>
#include <libgnomevfs/gnome-vfs-utils.h>

#include "globals.h"

gint delete_event(GtkWidget *widget, GdkEvent event, gpointer data)
{
	g_printf("\n%s\n","BYE!");
	gtk_main_quit();
	return TRUE;
}

void runAScript(gchar *commandLine)
{
	g_warning("%s",commandLine);
	g_spawn_command_line_sync(commandLine,NULL,NULL,NULL,NULL);
}

void doOpen(GtkButton *button, gpointer window_ptr)
{
	GtkWidget *dialog;

	dialog = gtk_file_chooser_dialog_new ("Open Playlist",
				      (GtkWindow*)window_ptr,
				      GTK_FILE_CHOOSER_ACTION_OPEN,
				      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
				      NULL);

	if (currentfilename!=NULL)
		gtk_file_chooser_set_filename((GtkFileChooser*)dialog,currentfilename);
	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
		{
		gchar *filename =gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		gtk_text_buffer_get_bounds(buffer,&start,&end);
		gtk_text_buffer_delete(buffer,&start,&end);
		gchar*	data;
		
		g_file_get_contents(filename,&data,NULL,NULL);
		gtk_text_buffer_insert_at_cursor(buffer,data,strlen(data));
		currentfilename=g_strdup(filename);
		}
	gtk_widget_destroy (dialog);

}

void doOk(GtkButton *button, gpointer window_ptr)
{
	GtkWidget *dialog;

	dialog = gtk_file_chooser_dialog_new ("Save Playlist As...",
				      (GtkWindow*)window_ptr,
				      GTK_FILE_CHOOSER_ACTION_SAVE,
				      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				      GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT,
				      NULL);

	gtk_file_chooser_set_do_overwrite_confirmation((GtkFileChooser*)dialog,true);
	if (currentfilename!=NULL)
		gtk_file_chooser_set_filename((GtkFileChooser*)dialog,currentfilename);
	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
		{
		gchar *filename=gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		if (g_str_has_suffix(filename,".m3u")!=TRUE)
			filename=g_strconcat(gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog)),".m3u",NULL);
		gtk_text_buffer_get_bounds(buffer,&start,&end);
		gchar	*data=g_strstrip(gtk_text_buffer_get_text(buffer,&start,&end,false));
		currentfilename=g_strdup(filename);
		g_file_set_contents(filename,data,-1,NULL);
		}
	gtk_widget_destroy (dialog);
}

void doCancel(GtkButton *button, gpointer window_ptr)
{
	gtk_text_buffer_get_bounds(buffer,&start,&end);
	gtk_text_buffer_delete(buffer,&start,&end);
}

void doSort(GtkButton *button, gpointer window_ptr)
{
	gchar	*temp;
	gboolean	flag;

	gtk_text_buffer_get_bounds(buffer,&start,&end);
	gchar	**dataarray=g_strsplit(g_strstrip(gtk_text_buffer_get_text(buffer,&start,&end,false)),"\n",-1);
	gtk_text_buffer_delete(buffer,&start,&end);
	
	do
		{
		flag=false;
		for (unsigned int j=0;j<g_strv_length(dataarray)-1;j++)
			{
			if (g_ascii_strcasecmp(dataarray[j],dataarray[j+1])>0)
				{
				flag=true;
				temp=dataarray[j];
				dataarray[j]=dataarray[j+1];
				dataarray[j+1]=temp;
				}
			}
		}
	while (flag==true);
		
	for (unsigned int j=0;j<g_strv_length(dataarray);j++)
		{
		temp=g_strconcat(dataarray[j],"\n",NULL);
		gtk_text_buffer_insert_at_cursor(buffer,temp,strlen(temp));
		g_free(temp);
		}
	g_strfreev(dataarray);


}

void doRandom(GtkButton *button, gpointer window_ptr)
{
	gchar	*temp;
	int	randnum;
	GRand	*rand=g_rand_new();

	gtk_text_buffer_get_bounds(buffer,&start,&end);
	gchar	**dataarray=g_strsplit(g_strstrip(gtk_text_buffer_get_text(buffer,&start,&end,false)),"\n",-1);
	gtk_text_buffer_delete(buffer,&start,&end);

	for (unsigned int j=0;j<g_strv_length(dataarray);j++)
		{
		randnum=g_rand_int_range(rand,0,g_strv_length(dataarray));
		temp=dataarray[j];
		dataarray[j]=dataarray[randnum];
		dataarray[randnum]=temp;
		}

	for (unsigned int j=0;j<g_strv_length(dataarray);j++)
		{
		temp=g_strconcat(dataarray[j],"\n",NULL);
		gtk_text_buffer_insert_at_cursor(buffer,temp,strlen(temp));
		g_free(temp);
		}
	g_strfreev(dataarray);
	g_rand_free(rand);
}

void dropped(GtkWidget *widget,GdkDragContext *context,gint x,gint y,GtkSelectionData *data,guint info,guint time)
{
	if (((*data).length >= 0) && ((*data).format == 8))
		{
		gchar*	dropData=g_strdup((gchar*)(*data).data);
		dropData=g_strdelimit(dropData,"\r",' ');
		gchar**	filelist=g_strsplit(dropData,"\n",-1);
		gtk_text_buffer_get_bounds(buffer,&start,&end);
		gtk_text_buffer_place_cursor(buffer,&end);
		for (unsigned int j=0; j<g_strv_length(filelist)-1;j++)
			{
			gchar*	fileName=g_strconcat(g_strstrip(gnome_vfs_format_uri_for_display(filelist[j])),"\n",NULL);
			if (g_str_has_suffix(fileName,".m4a\n")==TRUE || g_str_has_suffix(fileName,".mp3\n")==TRUE)
				{
				gtk_text_buffer_insert_at_cursor(buffer,fileName,strlen(fileName));
				}
			if (g_str_has_suffix(fileName,".m3u\n")==TRUE)
				{
				gchar*	filedata;
				g_file_get_contents(g_strstrip(fileName),&filedata,NULL,NULL);
				gtk_text_buffer_insert_at_cursor(buffer,filedata,strlen(filedata));
				g_free(filedata);
				}
			g_free(fileName);
			}
		g_free(dropData);
		g_strfreev(filelist);
		gtk_drag_finish (context, TRUE, FALSE, time);
		}
}

void dragdone(GtkButton *widget,gpointer user_data)
{
	gtk_entry_set_text((GtkEntry*)widget,"Drop Music File Here");
}

mainSignals theSignals[]={
				{"okclicked",doOk},
				{"cancelclicked",doCancel},
				{"doopen",doOpen},
				{"entrydropped",dragdone},
				{"dorandom",doRandom},
				{"sorted",doSort},
				{NULL,NULL}
			};
//				{"dragdrop",dropped},

int main(int argc, char **argv)
{
	
	GnomeProgram	*program;
	unsigned int	cnt=0;

	program = gnome_program_init("PlaylistMaker", "0.1",
                               LIBGNOMEUI_MODULE,
                               argc, argv,
                               GNOME_PROGRAM_STANDARD_PROPERTIES,
                               GNOME_PARAM_HUMAN_READABLE_NAME, "PlaylistMaker",
                               NULL);

	if (g_file_test(GLADEFILE,G_FILE_TEST_EXISTS)==TRUE)
		{
		gladepath=GLADEFILE;
		prefixPathToPix=PATHTOPIX;
		prefixPathToScripts=PATHTOSCRIPTS;
		}
	else
		{
		gladepath=gnome_program_locate_file(program,GNOME_FILE_DOMAIN_APP_DATADIR,GLADENAME,true,NULL);
		prefixPathToPix=gnome_program_locate_file(program,GNOME_FILE_DOMAIN_APP_DATADIR,"pixmaps",true,NULL);
		prefixPathToScripts=gnome_program_locate_file(program,GNOME_FILE_DOMAIN_APP_DATADIR,"scripts",true,NULL);
		}

	mainui = glade_xml_new(gladepath, NULL, NULL);
	mainwindow = GTK_WINDOW(glade_xml_get_widget(mainui, "mainwindow"));
	g_signal_connect(mainwindow, "delete-event", G_CALLBACK(delete_event), NULL);

	while (theSignals[cnt].name!=NULL)
		{
		glade_xml_signal_connect_data(mainui,theSignals[cnt].name,G_CALLBACK(theSignals[cnt].fptr),GUINT_TO_POINTER(mainwindow));
		cnt++;
		}
	glade_xml_signal_connect_data(mainui,"dragdrop",G_CALLBACK(dropped),GUINT_TO_POINTER(mainwindow));

	gtk_window_set_icon_from_file(mainwindow,g_strconcat(prefixPathToPix,"/playlistmaker.png",NULL),NULL);	
	gtk_widget_show((GtkWidget*)mainwindow);
	buffer=gtk_text_view_get_buffer((GtkTextView *)glade_xml_get_widget(mainui,"playlist"));

	gtk_main();
	return 0;
}

